/***
 * Excerpted from "Core Data, 2nd Edition",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/mzcd2 for more book information.
***/
#import "PPRecipe.h"

NSString *kPPImagePath = @"kPPImagePath";
NSString *kPPObjectID = @"kPPObjectID";
NSString *kPPServes = @"kPPServes";

@implementation PPRecipe

@dynamic desc;
@dynamic name;
@dynamic type;
@dynamic author;
@dynamic lastUsed;

- (NSDictionary*)metadata;
{
  NSMutableDictionary *metadataDict = [NSMutableDictionary dictionary];
  
  [metadataDict setValue:[self name] 
                  forKey:(id)kMDItemTitle];
  [metadataDict setValue:[self desc] 
                  forKey:(id)kMDItemTextContent];
  [metadataDict setValue:[[self author] valueForKey:@"name"] 
                  forKey:(id)kMDItemAuthors];
  [metadataDict setValue:[self valueForKey:@"imagePath"] 
                  forKey:kPPImagePath];
  [metadataDict setValue:[self lastUsed] forKey:(id)kMDItemLastUsedDate];
  [metadataDict setValue:[self valueForKey:@"serves"] forKey:kPPServes];
  [metadataDict setValue:[NSString stringWithFormat:@"Recipe: %@", [self name]] 
                  forKey:(id)kMDItemDisplayName];
  [metadataDict setValue:[[[self objectID] URIRepresentation] absoluteString] 
                  forKey:kPPObjectID];
  return metadataDict;
}

- (NSString*)metadataFilename;
{
  return [[self name] stringByAppendingPathExtension:@"grokkingrecipe"];
}

@end
